{$N+}
program pointlocation1;
uses   GritN,GritMath,cmstuf;
const  MAX=50;
type   edgetype = record x1,y1,x2,y2: extended; a: vec3 end;
       realarr  =array[0..MAX+1] of real;
var n,i,cnt,j,maxlevel,nedges: integer;
    a,q: vec3;
    u,v: realarr;
    uu,vv,p: real;
    edge: array[1..MAX+1] of edgetype;
    ade: byte;
    knop: integer;
    inside: boolean;
    binnenstring,buitenstring,kleurstring: string;

procedure lijn(p1,p2,q1,q2: real; var r: vec3);
begin
   r[1]:=p2-q2;
   r[2]:=-(p1-q1);
   r[3]:=(p1*q2)-(p2*q1);
end;

begin {main}

   hello('Program 6',
        'Position of a point with respect to a polygon',
        'uk');
   SetupGraphics;
   SetViewport(0,0, 1.0,0.7,white);
   SetWindow(0,0,28.6,20);
   SetMarkerMode(exclor);
   SetGraphtextMode(exclor);

   REPEAT
   ClearViewport;
   {definieer veelhoek}
   Prompt('Left-click at least 3 vertex points. Right-click AFTER the last point');
   i:=0;
   uu:=1E10;
   vv:=1E10;
   repeat
      Locator(uu,vv,knop);
      if knop=1 then
         begin
            i:=i+1;
            Marker(uu,vv,plus,lightred);
            u[i]:=uu; v[i]:=vv;
            if i>1 then ArrowLine(u[i-1],v[i-1],u[i],v[i],lightgreen)
         end
   until ((knop=2) and (i>2)) or (i=MAX);
   nedges:=i;
   u[0]:=u[nedges];   v[0]:=v[nedges];
   u[nedges+1]:=u[1]; v[nedges+1]:=v[1];
   ArrowLine(u[0],v[0],u[1],v[1],lightgreen);
   for i:=1 to nedges do   {definieer edges}
      with edge[i] do
         begin
            x1:=u[i]; y1:=v[i];
            x2:=u[i+1]; y2:=v[i+1];
(*          ArrowLine(x1,y1,x2,y2,lightgreen); *)
         end;
   {bereken coeff vectoren van edges}
   for i:=1 to nedges do
       with edge[i] do lijn(x1,y1,x2,y2,a);

   q[1]:=1000; q[2]:=1000;

   REPEAT
   Prompt('Click a point inside or outside the polygon');
   Locator(q[1],q[2],knop);
   Marker(q[1],q[2],plus,lightred);
   q[3]:=1.0;
   inside:=true;
   for i:=1 to nedges do
     begin
         p:=VVprod3(q,edge[i].a);
         if p>0 then inside:=false;
         if p>0 then with edge[i] do ArrowLine(x1,y1,x2,y2,lightred)
     end;
   kleurstring :='green/red line: point is to its right/left';
   binnenstring:='computer says: point is INSIDE the polygon';
   buitenstring:='computer says: point is OUTSIDE the polygon';
   GraphText(1,19,kleurstring,yellow);
   if inside then
     Graphtext(1,18,binnenstring,yellow)
   else
     Graphtext(1,18,buitenstring,yellow);
   Prompt('Left-click for next testpoint, right-click for new polygon or stop');
   Wait(-2,ade);
   Marker(q[1],q[2],plus,lightred);
  {erase}
   GraphText(1,19,kleurstring,yellow);
   if inside then
     Graphtext(1,18,binnenstring,yellow)
   else
     Graphtext(1,18,buitenstring,yellow);

   for i:=1 to nedges do with edge[i] do
                              ArrowLine(x1,y1,x2,y2,lightgreen);
   UNTIL ade=2;  {query punten lus}
   Prompt('Left-click for new polygon, right-click to stop');
   Wait(-2,ade)
   UNTIL ade=2;  {plaatjes lus}
   DoneGraphics
end.
